;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Effect Name : ?
;
; Description : ?
;
; Nb In       : 1
; Nb Out      : 1
;
; Input       : ?
; Output      : ?
;
; Cycles      : 240 + 54 cycles
; Memory      : 54 words (without init)
; Delay Line  : no
;
; Author      : AgALag (Axoris application generator)
; Date        : 
; Version     : 
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; INIT memory address
ABS INIT 0x3FF

	;; SEC1 Control parameters
ABS	constant4Cst	0x0
ABS	constant9Cst	0x1
ABS	saw14Ampl	0x2
ABS	saw14Delta	0x3
ABS	Feedbackpart12Feedback	0x6
ABS	InterpolateLog5Min	0x7
ABS	InterpolateLog5Max	0x8
ABS	Mixer2to113Scale1	0x9
ABS	Mixer2to113Scale2	0xA
ABS	BPFfreqin10W	0xB
ABS	gain3Gain	0x16
ABS	BPFfreqin12W	0x17
ABS	gain11Gain	0x22
ABS	HPFfreqin15W	0x23
ABS	Mixer2to16Scale1	0x2F
ABS	Mixer2to16Scale2	0x30
	;; SEC2 Initial values of control parameters (S3.24 format)
constant4ICst EQU 0.20
	
constant9ICst EQU 0.005
	
saw14IAmpl EQU 1.0
saw14IDelta EQU 0.00002
; 0x00a377f for 440 Hz
	
Feedbackpart12IFeedback EQU 0.5

InterpolateLog5IMin EQU 0.06
InterpolateLog5IMax EQU 0.20

Mixer2to113IScale1 EQU 1.0
Mixer2to113IScale2 EQU 0.0

BPFfreqin10IW EQU 1.2
	
gain3IGain EQU 1.4
	
BPFfreqin12IW EQU 1.2
	
gain11IGain EQU 4.0
	
HPFfreqin15IW EQU 2.0
	
;none

Mixer2to16IScale1 EQU 0.99
Mixer2to16IScale2 EQU 0.01

	;; SEC3 Constants definitions



;none


;none

BPFfreqin10C72 EQU -0.0139396
BPFfreqin10C56 EQU -0.0169386
BPFfreqin10C42 EQU -0.0238671
BPFfreqin10C30 EQU -0.0332733
BPFfreqin10C20 EQU -0.0500052
BPFfreqin10C12 EQU -0.0833286
BPFfreqin10C6 EQU -0.166667
BPFfreqin10C2 EQU -0.499999


BPFfreqin12C72 EQU -0.0139396
BPFfreqin12C56 EQU -0.0169386
BPFfreqin12C42 EQU -0.0238671
BPFfreqin12C30 EQU -0.0332733
BPFfreqin12C20 EQU -0.0500052
BPFfreqin12C12 EQU -0.0833286
BPFfreqin12C6 EQU -0.166667
BPFfreqin12C2 EQU -0.499999


HPFfreqin15C72 EQU -0.0139396
HPFfreqin15C56 EQU -0.0169386
HPFfreqin15C42 EQU -0.0238671
HPFfreqin15C30 EQU -0.0332733
HPFfreqin15C20 EQU -0.0500052
HPFfreqin15C12 EQU -0.0833286
HPFfreqin15C6 EQU -0.166667
HPFfreqin15C2 EQU 0.499999

;none

;none

	;; SEC4 Memory variables definition
ABS	saw14Value	0x4
ABS	Feedbackpart12FbState	0x5
ABS	BPFfreqin10A1	0xC
ABS	BPFfreqin10A2	0xD
ABS	BPFfreqin10B0	0xE
ABS	BPFfreqin10B1	0xF
ABS	BPFfreqin10B2	0x10
ABS	BPFfreqin10K	0x11
ABS	BPFfreqin10X1	0x12
ABS	BPFfreqin10X2	0x13
ABS	BPFfreqin10Y1	0x14
ABS	BPFfreqin10Y2	0x15
ABS	BPFfreqin12A1	0x18
ABS	BPFfreqin12A2	0x19
ABS	BPFfreqin12B0	0x1A
ABS	BPFfreqin12B1	0x1B
ABS	BPFfreqin12B2	0x1C
ABS	BPFfreqin12K	0x1D
ABS	BPFfreqin12X1	0x1E
ABS	BPFfreqin12X2	0x1F
ABS	BPFfreqin12Y1	0x20
ABS	BPFfreqin12Y2	0x21
ABS	HPFfreqin15A1	0x24
ABS	HPFfreqin15A2	0x25
ABS	HPFfreqin15B0	0x26
ABS	HPFfreqin15B1	0x27
ABS	HPFfreqin15B2	0x28
ABS	HPFfreqin15K	0x29
ABS	HPFfreqin15X1	0x2A
ABS	HPFfreqin15X2	0x2B
ABS	HPFfreqin15Y1	0x2C
ABS	HPFfreqin15Y2	0x2D
ABS	Feedbackpart21FbState	0x5
;; temporary IO for modules intercommunications
ABS	TMP0	0x31
ABS	TMP1	0x32
ABS	TMP2	0x33
ABS	TMP3	0x34
ABS	TMP4	0x35
	;; SEC5 Initial values of memory variables


saw14IValue EQU 0x0
	
Feedbackpart12IFbState EQU 0.0


;none






Feedbackpart21IFbState EQU 0.0

;none

	;; SEC6 Initialization
CM      0x40000 INIT
SKIP    !Z      EndInit
C constant4ICst
SCA 0x0 constant4Cst

C constant9ICst
SCA 0x0 constant9Cst

C saw14IValue ; load saw14Value
SCA 0x0 saw14Value
C saw14IAmpl ; load saw14Value
SCA 0x0 saw14Ampl
C saw14IDelta ; load saw14Value
SCA 0x0 saw14Delta

C Feedbackpart12IFeedback ; load Feedbackpart12IFeedback
SCA 0x0 Feedbackpart12Feedback ; save to Feedbackpart12Feedback
C Feedbackpart12IFbState ; load Feedbackpart12IFbState
SCA 0x0 Feedbackpart12FbState ; save to Feedbackpart12FbState

C InterpolateLog5IMin ; load init value for IdMin ...
SCA 0x0 InterpolateLog5Min ; ... Stored in dMin
C InterpolateLog5IMax ; load init value for IdMax ...
SCA 0x0 InterpolateLog5Max ; ... Stored in dMax

C Mixer2to113IScale1 ; load Mixer2to113IScale1
SCA 0x0 Mixer2to113Scale1 ; save to Mixer2to113Scale1
C Mixer2to113IScale2 ; load Mixer2to113IScale2
SCA 0x0 Mixer2to113Scale2 ; save to Mixer2to113Scale2

C BPFfreqin10IW
SCA 0x0 BPFfreqin10W
SCA 0x0 BPFfreqin10X1
SCA 0x0 BPFfreqin10X2
SCA 0x0 BPFfreqin10Y1
SCA 0x0 BPFfreqin10Y2

1AC gain3IGain ; initial default gain3Gain value
SCA 0x0 gain3Gain

C BPFfreqin12IW
SCA 0x0 BPFfreqin12W
SCA 0x0 BPFfreqin12X1
SCA 0x0 BPFfreqin12X2
SCA 0x0 BPFfreqin12Y1
SCA 0x0 BPFfreqin12Y2

1AC gain11IGain ; initial default gain11Gain value
SCA 0x0 gain11Gain

C HPFfreqin15IW
SCA 0x0 HPFfreqin15W
SCA 0x0 HPFfreqin15X1
SCA 0x0 HPFfreqin15X2
SCA 0x0 HPFfreqin15Y1
SCA 0x0 HPFfreqin15Y2

C Feedbackpart21IFbState ; load Feedbackpart21IFbState
SCA 0x0 Feedbackpart21FbState ; save to Feedbackpart21FbState

C Mixer2to16IScale1 ; load Mixer2to16IScale1
SCA 0x0 Mixer2to16Scale1 ; save to Mixer2to16Scale1
C Mixer2to16IScale2 ; load Mixer2to16IScale2
SCA 0x0 Mixer2to16Scale2 ; save to Mixer2to16Scale2

C 0x1000000	; Set A to 1
SCA 0x0 INIT	; do not reinitialise next time

EndInit:

	;; SEC7 Module code
CM 0x40000 constant4Cst
SCA 0x0 TMP0
CM 0x40000 constant9Cst
SCA 0x0 TMP1
CM 0x40000 saw14Value ; saw14Value -> A
CAM 0x40000 saw14Delta ; Value+Delta -> A
1AC 0xe000000 ; 'new'-Value - 1 -> A
SKIP N saw14continue
1AC 0xc000000 ; 'new'-Value - 1 -> A
saw14continue:
1AC 0x2000000 ; newValue -> A
SCA 0x10000 saw14Value ; save for next run
SCA 0x0 TMP2 ; write output
;;; Getting the Feedbackpart12Feedback and adding it to the input
1MC 0.0 Feedbackpart12FbState ; A = Feedbackpart12FbState
AMC 0.0 Feedbackpart12Feedback ; A = Feedbackpart12FbState * Feedbackpart12Feedback
CMA 1.0 IN1 ; A = InputSample + Feedbackpart12FbState * Feedbackpart12Feedback
SCA 0.0 TMP3 ; TMP3 = InputSample + Feedbackpart12FbState * Feedbackpart12Feedback

;; log16(in) -> [-6,0]
;; out = InterpolateLog5Min + (max-min) * (log16(in)+6)/6
CM 0x40000 TMP2 ; load input
SKIP !Z InterpolateLog5NonZero ; if IN=0, put 0x1
C 0x1
InterpolateLog5NonZero:
XCM 0x0 TMP2 ; IN->B
LOGB
CAD 0x0AAAA 0x100 ; rescale the log between 0 and 1
XCM 0x40000 InterpolateLog5Max ; log(IN)->B, Max->A
CMA 0x3c0000 InterpolateLog5Min ; Max-Min -> A
BAC 0x0
CAM 0x40000 InterpolateLog5Min ; InterpolateLog5Min + (Max-Min)*log
SCA 0x0 TMP4 ; write output
;;; Mixing the inputs
CM 1.0 Mixer2to113Scale1 ; A = Mixer2to113Scale1
AMC 0.0 TMP1 ; A = Mixer2to113Scale1 * input1
XCM 1.0 Mixer2to113Scale2 ; A = Mixer2to113Scale2 B = Mixer2to113Scale1 * input1
AMB TMP4 ; A = Mixer2to113Scale2 * input2 + Mixer2to113Scale1 * input1
SCA 0.0 TMP2 ; output = A

;; STEP 1: calculates coefficients
MMC 0x0 TMP2 ; load FRed^2 (IN2^2) in B
X1AC 0x0 ; store it in B
CAD BPFfreqin10C56 0x100 ; 1-x^2/56 -> A
BAC 0x0
CAD BPFfreqin10C30 0x100 ; 1-x^2/30 (1-x^2/56) -> A
BAC 0x0
CAD BPFfreqin10C12 0x100 ; 1-x^2/12 (...) -> A
BAC 0x0
CAD BPFfreqin10C2 0x100 ; cos = 1-x^2/2 (...) -> A
SCB 0x40000 BPFfreqin10A1 ; cos(FRed) in BPFfreqin10A1
CAD BPFfreqin10C72 0x100 ; 1-x^2/72 -> A
BAC 0x0
CAD BPFfreqin10C42 0x100 ; 1-x^2/42 (1-x^2/72) -> A
BAC 0x0
CAD BPFfreqin10C20 0x100 ; 1-x^2/20 (...) -> A
BAC 0x0
CAD BPFfreqin10C6 0x100 ; 1-x^2/6 (...) -> A
SXCA 0x0 BPFfreqin10K ; BPFfreqin10K = sin(FRed)/FRed in BPFfreqin10K and B.

;; calculates sinh(...)
LOGB
CAD 0x3c0000 0x0
X1AC 0x0
EXPB ; 1/K in A
AMC 0x0 BPFfreqin10W
DAC 0x20 0x0 ; W/8K in A
SXCA 0x3c0000 BPFfreqin10B0 ; W/8K in B, -W/8K in A, BPFfreqin10B0 irrelevant
SEXPB BPFfreqin10B0 ; use BPFfreqin10B0 to store -W/8K, 16^(W/8K) -> A
LCA 0x20000 BPFfreqin10B0 ; 1/2*16^(W/8K) -> A, -W/8K -> B
SEXPB BPFfreqin10B0 ; use BPFfreqin10B0 to store 1/2*16^(W/8K), 16^(-W/8K) -> A
CAM 0x3e0000 BPFfreqin10B0 ; sinh in A
AMC 0x0 TMP2
AMC 0x0 BPFfreqin10K ; ALPHA value in A
SCA 0x40000 BPFfreqin10B0 ; BPFfreqin10B0 = alpha (! not anymore the temp variable !)
1AC 0xF000000
SCA 0x40000 BPFfreqin10A2 ; BPFfreqin10A2 = ALPHA-1
1AC 0x2000000 ; 1+ALPHA -> A
X1AC 0x0
LOGB
CAD 0x3c0000 0x0
X1AC 0x0
EXPB
X1AC 0x0 ; 1/(1+ALPHA) -> A, B
AMC 0x0 BPFfreqin10A2 ; rescale BPFfreqin10A2
SCA 0x0 BPFfreqin10A2 ; and store it
BMC 0x0 BPFfreqin10B0 ; rescale BPFfreqin10B0
SCA 0x3c0000 BPFfreqin10B0 ; store it
SCA 0x0 BPFfreqin10B2 ; and fill BPFfreqin10B2
CM 0x80000 BPFfreqin10A1
BAC 0x0 ; update BPFfreqin10A1 (*2B)
SCA 0x0 BPFfreqin10A1
SCA 0x0 BPFfreqin10B1

;; STEP 2: filter
CM 0x40000 BPFfreqin10X2 ; x(i-2) -> A
AMC 0x0 BPFfreqin10B2 ; BPFfreqin10A2 x(i-2) -> A
XCM 0x40000 BPFfreqin10X1 ; A -> B and x(i-1) -> A
SCA 0x40000 BPFfreqin10X2 ; A unchanged, BPFfreqin10X1 will be BPFfreqin10X2 at next run
AMB BPFfreqin10B1 ; BPFfreqin10A1 x(i-1) + BPFfreqin10A2 x(i-2) -> A
XCM 0x40000 TMP3 ; A -> B and x(i) -> A
SCA 0x40000 BPFfreqin10X1 ; A unchanged, IN will be BPFfreqin10X1 at next run
AMB BPFfreqin10B0 ; a0 x(i)+a1 x(i-1)+a2 x(i-2) -> A
XCM 0x40000 BPFfreqin10Y2 ; A -> B and y(i-2) -> A
AMB BPFfreqin10A2 ; BPFfreqin10B2 y(i-2)+a0 x(i)+a1 x(i-1)+a2 x(i-2) -> A
XCM 0x40000 BPFfreqin10Y1 ; A -> B and x(i-1) -> A
SCA 0x40000 BPFfreqin10Y2 ; A unchanged, BPFfreqin10Y1 will be BPFfreqin10Y2 at next run
AMB BPFfreqin10A1 ; A not contins full output !
SCA 0x40000 BPFfreqin10Y1 ; A unchanged, OUT will be BPFfreqin10Y1 at next run
SCA 0x0 TMP1 ; write output !
CM 0x40000 TMP1 ; load input
AMC 0x0 gain3Gain ; amplify
SCA 0x0 TMP3 ; write output and restore 0 in A

;; STEP 1: calculates coefficients
MMC 0x0 TMP2 ; load FRed^2 (IN2^2) in B
X1AC 0x0 ; store it in B
CAD BPFfreqin12C56 0x100 ; 1-x^2/56 -> A
BAC 0x0
CAD BPFfreqin12C30 0x100 ; 1-x^2/30 (1-x^2/56) -> A
BAC 0x0
CAD BPFfreqin12C12 0x100 ; 1-x^2/12 (...) -> A
BAC 0x0
CAD BPFfreqin12C2 0x100 ; cos = 1-x^2/2 (...) -> A
SCB 0x40000 BPFfreqin12A1 ; cos(FRed) in BPFfreqin12A1
CAD BPFfreqin12C72 0x100 ; 1-x^2/72 -> A
BAC 0x0
CAD BPFfreqin12C42 0x100 ; 1-x^2/42 (1-x^2/72) -> A
BAC 0x0
CAD BPFfreqin12C20 0x100 ; 1-x^2/20 (...) -> A
BAC 0x0
CAD BPFfreqin12C6 0x100 ; 1-x^2/6 (...) -> A
SXCA 0x0 BPFfreqin12K ; BPFfreqin12K = sin(FRed)/FRed in BPFfreqin12K and B.

;; calculates sinh(...)
LOGB
CAD 0x3c0000 0x0
X1AC 0x0
EXPB ; 1/K in A
AMC 0x0 BPFfreqin12W
DAC 0x20 0x0 ; W/8K in A
SXCA 0x3c0000 BPFfreqin12B0 ; W/8K in B, -W/8K in A, BPFfreqin12B0 irrelevant
SEXPB BPFfreqin12B0 ; use BPFfreqin12B0 to store -W/8K, 16^(W/8K) -> A
LCA 0x20000 BPFfreqin12B0 ; 1/2*16^(W/8K) -> A, -W/8K -> B
SEXPB BPFfreqin12B0 ; use BPFfreqin12B0 to store 1/2*16^(W/8K), 16^(-W/8K) -> A
CAM 0x3e0000 BPFfreqin12B0 ; sinh in A
AMC 0x0 TMP2
AMC 0x0 BPFfreqin12K ; ALPHA value in A
SCA 0x40000 BPFfreqin12B0 ; BPFfreqin12B0 = alpha (! not anymore the temp variable !)
1AC 0xF000000
SCA 0x40000 BPFfreqin12A2 ; BPFfreqin12A2 = ALPHA-1
1AC 0x2000000 ; 1+ALPHA -> A
X1AC 0x0
LOGB
CAD 0x3c0000 0x0
X1AC 0x0
EXPB
X1AC 0x0 ; 1/(1+ALPHA) -> A, B
AMC 0x0 BPFfreqin12A2 ; rescale BPFfreqin12A2
SCA 0x0 BPFfreqin12A2 ; and store it
BMC 0x0 BPFfreqin12B0 ; rescale BPFfreqin12B0
SCA 0x3c0000 BPFfreqin12B0 ; store it
SCA 0x0 BPFfreqin12B2 ; and fill BPFfreqin12B2
CM 0x80000 BPFfreqin12A1
BAC 0x0 ; update BPFfreqin12A1 (*2B)
SCA 0x0 BPFfreqin12A1
SCA 0x0 BPFfreqin12B1

;; STEP 2: filter
CM 0x40000 BPFfreqin12X2 ; x(i-2) -> A
AMC 0x0 BPFfreqin12B2 ; BPFfreqin12A2 x(i-2) -> A
XCM 0x40000 BPFfreqin12X1 ; A -> B and x(i-1) -> A
SCA 0x40000 BPFfreqin12X2 ; A unchanged, BPFfreqin12X1 will be BPFfreqin12X2 at next run
AMB BPFfreqin12B1 ; BPFfreqin12A1 x(i-1) + BPFfreqin12A2 x(i-2) -> A
XCM 0x40000 TMP3 ; A -> B and x(i) -> A
SCA 0x40000 BPFfreqin12X1 ; A unchanged, IN will be BPFfreqin12X1 at next run
AMB BPFfreqin12B0 ; a0 x(i)+a1 x(i-1)+a2 x(i-2) -> A
XCM 0x40000 BPFfreqin12Y2 ; A -> B and y(i-2) -> A
AMB BPFfreqin12A2 ; BPFfreqin12B2 y(i-2)+a0 x(i)+a1 x(i-1)+a2 x(i-2) -> A
XCM 0x40000 BPFfreqin12Y1 ; A -> B and x(i-1) -> A
SCA 0x40000 BPFfreqin12Y2 ; A unchanged, BPFfreqin12Y1 will be BPFfreqin12Y2 at next run
AMB BPFfreqin12A1 ; A not contins full output !
SCA 0x40000 BPFfreqin12Y1 ; A unchanged, OUT will be BPFfreqin12Y1 at next run
SCA 0x0 TMP1 ; write output !
CM 0x40000 TMP1 ; load input
AMC 0x0 gain11Gain ; amplify
SCA 0x0 TMP2 ; write output and restore 0 in A

;; STEP 1: calculates coefficients
MMC 0x0 TMP0 ; load FRed^2 in B
X1AC 0x0 ; store it in B
CAD HPFfreqin15C56 0x100 ; 1-x^2/56 -> A
BAC 0x0
CAD HPFfreqin15C30 0x100 ; 1-x^2/30 (1-x^2/56) -> A
BAC 0x0
CAD HPFfreqin15C12 0x100 ; 1-x^2/12 (...) -> A
BAC 0x0
CAD HPFfreqin15C2 0xF00 ; -cos = -(1-x^2/2 (...)) -> A
SCB 0x40000 HPFfreqin15A1 ; -cos(FRed) in HPFfreqin15A1
CAD HPFfreqin15C72 0x100 ; 1-x^2/72 -> A
BAC 0x0
CAD HPFfreqin15C42 0x100 ; 1-x^2/42 (1-x^2/72) -> A
BAC 0x0
CAD HPFfreqin15C20 0x100 ; 1-x^2/20 (...) -> A
BAC 0x0
CAD HPFfreqin15C6 0x100 ; 1-x^2/6 (...) -> A
SXCA 0x0 HPFfreqin15K ; HPFfreqin15K = sin(FRed)/FRed in HPFfreqin15K and B.

;; calculates sinh(...)
LOGB
CAD 0x3c0000 0x0
X1AC 0x0
EXPB ; 1/K in A
AMC 0x0 HPFfreqin15W
DAC 0x20 0x0 ; W/8K in A
SXCA 0x3c0000 HPFfreqin15B0 ; W/8K in B, -W/8K in A, HPFfreqin15B0 irrelevant
SEXPB HPFfreqin15B0 ; use HPFfreqin15B0 to store -W/8K, 16^(W/8K) -> A
LCA 0x20000 HPFfreqin15B0 ; 1/2*16^(W/8K) -> A, -W/8K -> B
SEXPB HPFfreqin15B0 ; use HPFfreqin15B0 to store 1/2*16^(W/8K), 16^(-W/8K) -> A
CAM 0x3e0000 HPFfreqin15B0 ; sinh in A
AMC 0x0 TMP0
AMC 0x0 HPFfreqin15K ; ALPHA value in A
1AC 0xF000000
SCA 0x40000 HPFfreqin15A2 ; HPFfreqin15A2 = ALPHA-1
1AC 0x2000000 ; 1+ALPHA -> A
X1AC 0x0
LOGB
CAD 0x3c0000 0x0
X1AC 0x0
EXPB
X1AC 0x0 ; 1/(1+ALPHA) -> A, B
AMC 0x0 HPFfreqin15A2 ; rescale HPFfreqin15A2
SCA 0x0 HPFfreqin15A2 ; and store it
1MC 0x3c0000 HPFfreqin15A1 ; -1-cos -> A
BAC 0x0 ; rescale it
SCA 0x3e0000 HPFfreqin15B1 ; store HPFfreqin15B1
SCA 0x40000 HPFfreqin15B0 ; store HPFfreqin15B0
SCA 0x0 HPFfreqin15B2 ; store HPFfreqin15B2
CM 0x380000 HPFfreqin15A1
BAC 0x0 ; update HPFfreqin15A1 (*2B)
SCA 0x0 HPFfreqin15A1

;; STEP 2: filter
CM 0x40000 HPFfreqin15X2 ; x(i-2) -> A
AMC 0x0 HPFfreqin15B2 ; HPFfreqin15A2 x(i-2) -> A
XCM 0x40000 HPFfreqin15X1 ; A -> B and x(i-1) -> A
SCA 0x40000 HPFfreqin15X2 ; A unchanged, HPFfreqin15X1 will be HPFfreqin15X2 at next run
AMB HPFfreqin15B1 ; HPFfreqin15A1 x(i-1) + HPFfreqin15A2 x(i-2) -> A
XCM 0x40000 TMP1 ; A -> B and x(i) -> A
SCA 0x40000 HPFfreqin15X1 ; A unchanged, IN will be HPFfreqin15X1 at next run
AMB HPFfreqin15B0 ; a0 x(i)+a1 x(i-1)+a2 x(i-2) -> A
XCM 0x40000 HPFfreqin15Y2 ; A -> B and y(i-2) -> A
AMB HPFfreqin15A2 ; HPFfreqin15B2 y(i-2)+a0 x(i)+a1 x(i-1)+a2 x(i-2) -> A
XCM 0x40000 HPFfreqin15Y1 ; A -> B and x(i-1) -> A
SCA 0x40000 HPFfreqin15Y2 ; A unchanged, HPFfreqin15Y1 will be HPFfreqin15Y2 at next run
AMB HPFfreqin15A1 ; A not contins full output !
SCA 0x40000 HPFfreqin15Y1 ; A unchanged, OUT will be HPFfreqin15Y1 at next run
SCA 0x0 TMP3 ; write output !
;;; Getting the feedback and adding it to the input
1MC 0.0 TMP3 ; A = TMP3
SCA 1.0 Feedbackpart21FbState ; Update the feedback path with the new input

;;; Mixing the inputs
CM 1.0 Mixer2to16Scale1 ; A = Mixer2to16Scale1
AMC 0.0 IN1 ; A = Mixer2to16Scale1 * input1
XCM 1.0 Mixer2to16Scale2 ; A = Mixer2to16Scale2 B = Mixer2to16Scale1 * input1
AMB TMP2 ; A = Mixer2to16Scale2 * input2 + Mixer2to16Scale1 * input1
SCA 0.0 OUT1 ; output = A
